package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetCharactersCharacterIDBlueprintsReader is a Reader for the GetCharactersCharacterIDBlueprints structure.
type GetCharactersCharacterIDBlueprintsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDBlueprintsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDBlueprintsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDBlueprintsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDBlueprintsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDBlueprintsOK creates a GetCharactersCharacterIDBlueprintsOK with default headers values
func NewGetCharactersCharacterIDBlueprintsOK() *GetCharactersCharacterIDBlueprintsOK {
	return &GetCharactersCharacterIDBlueprintsOK{}
}

/*GetCharactersCharacterIDBlueprintsOK handles this case with default header values.

A list of blueprints
*/
type GetCharactersCharacterIDBlueprintsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDBlueprintsOKBodyItems0
}

func (o *GetCharactersCharacterIDBlueprintsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/blueprints/][%d] getCharactersCharacterIdBlueprintsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDBlueprintsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBlueprintsForbidden creates a GetCharactersCharacterIDBlueprintsForbidden with default headers values
func NewGetCharactersCharacterIDBlueprintsForbidden() *GetCharactersCharacterIDBlueprintsForbidden {
	return &GetCharactersCharacterIDBlueprintsForbidden{}
}

/*GetCharactersCharacterIDBlueprintsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDBlueprintsForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDBlueprintsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/blueprints/][%d] getCharactersCharacterIdBlueprintsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDBlueprintsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBlueprintsInternalServerError creates a GetCharactersCharacterIDBlueprintsInternalServerError with default headers values
func NewGetCharactersCharacterIDBlueprintsInternalServerError() *GetCharactersCharacterIDBlueprintsInternalServerError {
	return &GetCharactersCharacterIDBlueprintsInternalServerError{}
}

/*GetCharactersCharacterIDBlueprintsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDBlueprintsInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDBlueprintsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/blueprints/][%d] getCharactersCharacterIdBlueprintsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDBlueprintsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDBlueprintsOKBodyItems0 get_characters_character_id_blueprints_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDBlueprintsOKBodyItems0
*/
type GetCharactersCharacterIDBlueprintsOKBodyItems0 struct {

	// get_characters_character_id_blueprints_item_id
	//
	// Unique ID for this item. The ID of an item is stable if that item is not repackaged, stacked, detached from a stack, assembled, or otherwise altered. If an item is changed in one of these ways, then the ID will also change (see notes below).
	// Required: true
	ItemID *int64 `json:"item_id"`

	// get_characters_character_id_blueprints_location_flag
	//
	// Indicates something about this item's storage location. The flag is used to differentiate between hangar divisions, drone bay, fitting location, and similar.
	// Required: true
	LocationFlag *string `json:"location_flag"`

	// get_characters_character_id_blueprints_location_id
	//
	// References a solar system, station or itemID if this blueprint is located within a container. If an itemID the Character - AssetList API must be queried to find the container using the itemID, from which the correct location of the Blueprint can be derived.
	// Required: true
	LocationID *int64 `json:"location_id"`

	// get_characters_character_id_blueprints_material_efficiency
	//
	// Material Efficiency Level of the blueprint, can be any integer between 0 and 10.
	// Required: true
	MaterialEfficiency *int32 `json:"material_efficiency"`

	// get_characters_character_id_blueprints_quantity
	//
	// Typically will be -1 or -2 designating a singleton item, where -1 is an original and -2 is a copy. It can be a positive integer if it is a stack of blueprint originals fresh from the market (no activities performed on them yet).
	// Required: true
	Quantity *int32 `json:"quantity"`

	// get_characters_character_id_blueprints_runs
	//
	// Number of runs remaining if the blueprint is a copy, -1 if it is an original.
	// Required: true
	Runs *int32 `json:"runs"`

	// get_characters_character_id_blueprints_time_efficiency
	//
	// Time Efficiency Level of the blueprint, can be any even integer between 0 and 20.
	// Required: true
	TimeEfficiency *int32 `json:"time_efficiency"`

	// get_characters_character_id_blueprints_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}
