package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetCharactersCharacterIDChatChannelsReader is a Reader for the GetCharactersCharacterIDChatChannels structure.
type GetCharactersCharacterIDChatChannelsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDChatChannelsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDChatChannelsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDChatChannelsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDChatChannelsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDChatChannelsOK creates a GetCharactersCharacterIDChatChannelsOK with default headers values
func NewGetCharactersCharacterIDChatChannelsOK() *GetCharactersCharacterIDChatChannelsOK {
	return &GetCharactersCharacterIDChatChannelsOK{}
}

/*GetCharactersCharacterIDChatChannelsOK handles this case with default header values.

A list of chat channels
*/
type GetCharactersCharacterIDChatChannelsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDChatChannelsOKBodyItems0
}

func (o *GetCharactersCharacterIDChatChannelsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/chat_channels/][%d] getCharactersCharacterIdChatChannelsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDChatChannelsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDChatChannelsForbidden creates a GetCharactersCharacterIDChatChannelsForbidden with default headers values
func NewGetCharactersCharacterIDChatChannelsForbidden() *GetCharactersCharacterIDChatChannelsForbidden {
	return &GetCharactersCharacterIDChatChannelsForbidden{}
}

/*GetCharactersCharacterIDChatChannelsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDChatChannelsForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDChatChannelsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/chat_channels/][%d] getCharactersCharacterIdChatChannelsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDChatChannelsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDChatChannelsInternalServerError creates a GetCharactersCharacterIDChatChannelsInternalServerError with default headers values
func NewGetCharactersCharacterIDChatChannelsInternalServerError() *GetCharactersCharacterIDChatChannelsInternalServerError {
	return &GetCharactersCharacterIDChatChannelsInternalServerError{}
}

/*GetCharactersCharacterIDChatChannelsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDChatChannelsInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDChatChannelsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/chat_channels/][%d] getCharactersCharacterIdChatChannelsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDChatChannelsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDChatChannelsOKBodyItems0 get_characters_character_id_chat_channels_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDChatChannelsOKBodyItems0
*/
type GetCharactersCharacterIDChatChannelsOKBodyItems0 struct {

	// get_characters_character_id_chat_channels_allowed
	//
	// allowed array
	// Required: true
	// Max Items: 1000
	Allowed []*GetCharactersCharacterIDChatChannelsOKBodyItems0AllowedItems0 `json:"allowed"`

	// get_characters_character_id_chat_channels_blocked
	//
	// blocked array
	// Required: true
	// Max Items: 1000
	Blocked []*GetCharactersCharacterIDChatChannelsOKBodyItems0BlockedItems0 `json:"blocked"`

	// get_characters_character_id_chat_channels_channel_id
	//
	// Unique channel ID. Always negative for player-created channels. Permanent (CCP created) channels have a positive ID, but don't appear in the API
	// Required: true
	ChannelID *int32 `json:"channel_id"`

	// get_characters_character_id_chat_channels_comparison_key
	//
	// Normalized, unique string used to compare channel names
	// Required: true
	ComparisonKey *string `json:"comparison_key"`

	// get_characters_character_id_chat_channels_has_password
	//
	// Whether this is a password protected channel
	// Required: true
	HasPassword *bool `json:"has_password"`

	// get_characters_character_id_chat_channels_motd
	//
	// Message of the day for this channel
	// Required: true
	Motd *string `json:"motd"`

	// get_characters_character_id_chat_channels_muted
	//
	// muted array
	// Required: true
	// Max Items: 1000
	Muted []*GetCharactersCharacterIDChatChannelsOKBodyItems0MutedItems0 `json:"muted"`

	// get_characters_character_id_chat_channels_name
	//
	// Displayed name of channel
	// Required: true
	Name *string `json:"name"`

	// get_characters_character_id_chat_channels_operators
	//
	// operators array
	// Required: true
	// Max Items: 1000
	Operators []*GetCharactersCharacterIDChatChannelsOKBodyItems0OperatorsItems0 `json:"operators"`

	// get_characters_character_id_chat_channels_owner_id
	//
	// owner_id integer
	// Required: true
	OwnerID *int32 `json:"owner_id"`
}

/*GetCharactersCharacterIDChatChannelsOKBodyItems0BlockedItems0 get_characters_character_id_chat_channels_blocked
//
// blocked object
swagger:model GetCharactersCharacterIDChatChannelsOKBodyItems0BlockedItems0
*/
type GetCharactersCharacterIDChatChannelsOKBodyItems0BlockedItems0 struct {

	// get_characters_character_id_chat_channels_accessor_id
	//
	// ID of a blocked channel member
	// Required: true
	AccessorID *int32 `json:"accessor_id"`

	// get_characters_character_id_chat_channels_accessor_type
	//
	// accessor_type string
	// Required: true
	AccessorType *string `json:"accessor_type"`

	// get_characters_character_id_chat_channels_end_at
	//
	// Time at which this accessor will no longer be blocked
	EndAt strfmt.DateTime `json:"end_at,omitempty"`

	// get_characters_character_id_chat_channels_reason
	//
	// Reason this accessor is blocked
	Reason string `json:"reason,omitempty"`
}

/*GetCharactersCharacterIDChatChannelsOKBodyItems0MutedItems0 get_characters_character_id_chat_channels_muted
//
// muted object
swagger:model GetCharactersCharacterIDChatChannelsOKBodyItems0MutedItems0
*/
type GetCharactersCharacterIDChatChannelsOKBodyItems0MutedItems0 struct {

	// get_characters_character_id_chat_channels_accessor_id
	//
	// ID of a muted channel member
	// Required: true
	AccessorID *int32 `json:"accessor_id"`

	// get_characters_character_id_chat_channels_accessor_type
	//
	// accessor_type string
	// Required: true
	AccessorType *string `json:"accessor_type"`

	// get_characters_character_id_chat_channels_end_at
	//
	// Time at which this accessor will no longer be muted
	EndAt strfmt.DateTime `json:"end_at,omitempty"`

	// get_characters_character_id_chat_channels_reason
	//
	// Reason this accessor is muted
	Reason string `json:"reason,omitempty"`
}

/*GetCharactersCharacterIDChatChannelsOKBodyItems0OperatorsItems0 get_characters_character_id_chat_channels_operator
//
// operator object
swagger:model GetCharactersCharacterIDChatChannelsOKBodyItems0OperatorsItems0
*/
type GetCharactersCharacterIDChatChannelsOKBodyItems0OperatorsItems0 struct {

	// get_characters_character_id_chat_channels_accessor_id
	//
	// ID of a channel operator
	// Required: true
	AccessorID *int32 `json:"accessor_id"`

	// get_characters_character_id_chat_channels_accessor_type
	//
	// accessor_type string
	// Required: true
	AccessorType *string `json:"accessor_type"`
}

/*GetCharactersCharacterIDChatChannelsOKBodyItems0AllowedItems0 get_characters_character_id_chat_channels_allowed
//
// allowed object
swagger:model GetCharactersCharacterIDChatChannelsOKBodyItems0AllowedItems0
*/
type GetCharactersCharacterIDChatChannelsOKBodyItems0AllowedItems0 struct {

	// get_characters_character_id_chat_channels_accessor_id
	//
	// ID of an allowed channel member
	// Required: true
	AccessorID *int32 `json:"accessor_id"`

	// get_characters_character_id_chat_channels_accessor_type
	//
	// accessor_type string
	// Required: true
	AccessorType *string `json:"accessor_type"`
}
