package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetCharactersCharacterIDMedalsReader is a Reader for the GetCharactersCharacterIDMedals structure.
type GetCharactersCharacterIDMedalsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDMedalsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDMedalsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDMedalsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDMedalsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDMedalsOK creates a GetCharactersCharacterIDMedalsOK with default headers values
func NewGetCharactersCharacterIDMedalsOK() *GetCharactersCharacterIDMedalsOK {
	return &GetCharactersCharacterIDMedalsOK{}
}

/*GetCharactersCharacterIDMedalsOK handles this case with default header values.

A list of medals
*/
type GetCharactersCharacterIDMedalsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDMedalsOKBodyItems0
}

func (o *GetCharactersCharacterIDMedalsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/medals/][%d] getCharactersCharacterIdMedalsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDMedalsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDMedalsForbidden creates a GetCharactersCharacterIDMedalsForbidden with default headers values
func NewGetCharactersCharacterIDMedalsForbidden() *GetCharactersCharacterIDMedalsForbidden {
	return &GetCharactersCharacterIDMedalsForbidden{}
}

/*GetCharactersCharacterIDMedalsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDMedalsForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDMedalsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/medals/][%d] getCharactersCharacterIdMedalsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDMedalsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDMedalsInternalServerError creates a GetCharactersCharacterIDMedalsInternalServerError with default headers values
func NewGetCharactersCharacterIDMedalsInternalServerError() *GetCharactersCharacterIDMedalsInternalServerError {
	return &GetCharactersCharacterIDMedalsInternalServerError{}
}

/*GetCharactersCharacterIDMedalsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDMedalsInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDMedalsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/medals/][%d] getCharactersCharacterIdMedalsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDMedalsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDMedalsOKBodyItems0 get_characters_character_id_medals_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDMedalsOKBodyItems0
*/
type GetCharactersCharacterIDMedalsOKBodyItems0 struct {

	// get_characters_character_id_medals_corporation_id
	//
	// corporation_id integer
	// Required: true
	CorporationID *int32 `json:"corporation_id"`

	// get_characters_character_id_medals_date
	//
	// date string
	// Required: true
	Date *strfmt.DateTime `json:"date"`

	// get_characters_character_id_medals_description
	//
	// description string
	// Required: true
	Description *string `json:"description"`

	// get_characters_character_id_medals_graphics
	//
	// graphics array
	// Required: true
	// Max Items: 10
	Graphics []*GetCharactersCharacterIDMedalsOKBodyItems0GraphicsItems0 `json:"graphics"`

	// get_characters_character_id_medals_issuer_id
	//
	// issuer_id integer
	// Required: true
	IssuerID *int32 `json:"issuer_id"`

	// get_characters_character_id_medals_medal_id
	//
	// medal_id integer
	// Required: true
	MedalID *int32 `json:"medal_id"`

	// get_characters_character_id_medals_reason
	//
	// reason string
	// Required: true
	Reason *string `json:"reason"`

	// get_characters_character_id_medals_status
	//
	// status string
	// Required: true
	Status *string `json:"status"`

	// get_characters_character_id_medals_title
	//
	// title string
	// Required: true
	Title *string `json:"title"`
}

/*GetCharactersCharacterIDMedalsOKBodyItems0GraphicsItems0 get_characters_character_id_medals_graphic
//
// graphic object
swagger:model GetCharactersCharacterIDMedalsOKBodyItems0GraphicsItems0
*/
type GetCharactersCharacterIDMedalsOKBodyItems0GraphicsItems0 struct {

	// get_characters_character_id_medals_color
	//
	// color integer
	Color int32 `json:"color,omitempty"`

	// get_characters_character_id_medals_graphic
	//
	// graphic string
	// Required: true
	Graphic *string `json:"graphic"`

	// get_characters_character_id_medals_layer
	//
	// layer integer
	// Required: true
	Layer *int32 `json:"layer"`

	// get_characters_character_id_medals_part
	//
	// part integer
	// Required: true
	Part *int32 `json:"part"`
}
