package faction_warfare

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetFwStatsReader is a Reader for the GetFwStats structure.
type GetFwStatsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFwStatsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFwStatsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetFwStatsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFwStatsOK creates a GetFwStatsOK with default headers values
func NewGetFwStatsOK() *GetFwStatsOK {
	return &GetFwStatsOK{}
}

/*GetFwStatsOK handles this case with default header values.

Per faction breakdown of faction warfare statistics
*/
type GetFwStatsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetFwStatsOKBodyItems0
}

func (o *GetFwStatsOK) Error() string {
	return fmt.Sprintf("[GET /fw/stats/][%d] getFwStatsOK  %+v", 200, o.Payload)
}

func (o *GetFwStatsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFwStatsInternalServerError creates a GetFwStatsInternalServerError with default headers values
func NewGetFwStatsInternalServerError() *GetFwStatsInternalServerError {
	return &GetFwStatsInternalServerError{}
}

/*GetFwStatsInternalServerError handles this case with default header values.

Internal server error
*/
type GetFwStatsInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetFwStatsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /fw/stats/][%d] getFwStatsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFwStatsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetFwStatsOKBodyItems0Kills get_fw_stats_kills
//
// Summary of kills against an enemy faction for the given faction
swagger:model GetFwStatsOKBodyItems0Kills
*/
type GetFwStatsOKBodyItems0Kills struct {

	// get_fw_stats_last_week
	//
	// Last week's total number of kills against enemy factions
	// Required: true
	LastWeek *int32 `json:"last_week"`

	// get_fw_stats_total
	//
	// Total number of kills against enemy factions since faction warfare began
	// Required: true
	Total *int32 `json:"total"`

	// get_fw_stats_yesterday
	//
	// Yesterday's total number of kills against enemy factions
	// Required: true
	Yesterday *int32 `json:"yesterday"`
}

/*GetFwStatsOKBodyItems0VictoryPoints get_fw_stats_victory_points
//
// Summary of victory points gained for the given faction
swagger:model GetFwStatsOKBodyItems0VictoryPoints
*/
type GetFwStatsOKBodyItems0VictoryPoints struct {

	// get_fw_stats_last_week
	//
	// Last week's victory points gained
	// Required: true
	LastWeek *int32 `json:"last_week"`

	// get_fw_stats_total
	//
	// Total victory points gained since faction warfare began
	// Required: true
	Total *int32 `json:"total"`

	// get_fw_stats_yesterday
	//
	// Yesterday's victory points gained
	// Required: true
	Yesterday *int32 `json:"yesterday"`
}

/*GetFwStatsOKBodyItems0 get_fw_stats_200_ok
//
// 200 ok object
swagger:model GetFwStatsOKBodyItems0
*/
type GetFwStatsOKBodyItems0 struct {

	// get_fw_stats_faction_id
	//
	// faction_id integer
	// Required: true
	FactionID *int32 `json:"faction_id"`

	// kills
	// Required: true
	Kills *GetFwStatsOKBodyItems0Kills `json:"kills"`

	// get_fw_stats_pilots
	//
	// How many pilots fight for the given faction
	// Required: true
	Pilots *int32 `json:"pilots"`

	// get_fw_stats_systems_controlled
	//
	// The number of solar systems controlled by the given faction
	// Required: true
	SystemsControlled *int32 `json:"systems_controlled"`

	// victory points
	// Required: true
	VictoryPoints *GetFwStatsOKBodyItems0VictoryPoints `json:"victory_points"`
}
