package industry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetCharactersCharacterIDIndustryJobsReader is a Reader for the GetCharactersCharacterIDIndustryJobs structure.
type GetCharactersCharacterIDIndustryJobsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDIndustryJobsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDIndustryJobsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDIndustryJobsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDIndustryJobsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDIndustryJobsOK creates a GetCharactersCharacterIDIndustryJobsOK with default headers values
func NewGetCharactersCharacterIDIndustryJobsOK() *GetCharactersCharacterIDIndustryJobsOK {
	return &GetCharactersCharacterIDIndustryJobsOK{}
}

/*GetCharactersCharacterIDIndustryJobsOK handles this case with default header values.

Industry jobs placed by a character
*/
type GetCharactersCharacterIDIndustryJobsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDIndustryJobsOKBodyItems0
}

func (o *GetCharactersCharacterIDIndustryJobsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/industry/jobs/][%d] getCharactersCharacterIdIndustryJobsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDIndustryJobsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDIndustryJobsForbidden creates a GetCharactersCharacterIDIndustryJobsForbidden with default headers values
func NewGetCharactersCharacterIDIndustryJobsForbidden() *GetCharactersCharacterIDIndustryJobsForbidden {
	return &GetCharactersCharacterIDIndustryJobsForbidden{}
}

/*GetCharactersCharacterIDIndustryJobsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDIndustryJobsForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDIndustryJobsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/industry/jobs/][%d] getCharactersCharacterIdIndustryJobsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDIndustryJobsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDIndustryJobsInternalServerError creates a GetCharactersCharacterIDIndustryJobsInternalServerError with default headers values
func NewGetCharactersCharacterIDIndustryJobsInternalServerError() *GetCharactersCharacterIDIndustryJobsInternalServerError {
	return &GetCharactersCharacterIDIndustryJobsInternalServerError{}
}

/*GetCharactersCharacterIDIndustryJobsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDIndustryJobsInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDIndustryJobsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/industry/jobs/][%d] getCharactersCharacterIdIndustryJobsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDIndustryJobsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDIndustryJobsOKBodyItems0 get_characters_character_id_industry_jobs_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDIndustryJobsOKBodyItems0
*/
type GetCharactersCharacterIDIndustryJobsOKBodyItems0 struct {

	// get_characters_character_id_industry_jobs_activity_id
	//
	// Job activity ID
	// Required: true
	ActivityID *int32 `json:"activity_id"`

	// get_characters_character_id_industry_jobs_blueprint_id
	//
	// blueprint_id integer
	// Required: true
	BlueprintID *int64 `json:"blueprint_id"`

	// get_characters_character_id_industry_jobs_blueprint_location_id
	//
	// Location ID of the location from which the blueprint was installed. Normally a station ID, but can also be an asset (e.g. container) or corporation facility
	// Required: true
	BlueprintLocationID *int64 `json:"blueprint_location_id"`

	// get_characters_character_id_industry_jobs_blueprint_type_id
	//
	// blueprint_type_id integer
	// Required: true
	BlueprintTypeID *int32 `json:"blueprint_type_id"`

	// get_characters_character_id_industry_jobs_completed_character_id
	//
	// ID of the character which completed this job
	CompletedCharacterID int32 `json:"completed_character_id,omitempty"`

	// get_characters_character_id_industry_jobs_completed_date
	//
	// Date and time when this job was completed
	CompletedDate strfmt.DateTime `json:"completed_date,omitempty"`

	// get_characters_character_id_industry_jobs_cost
	//
	// The sume of job installation fee and industry facility tax
	Cost float32 `json:"cost,omitempty"`

	// get_characters_character_id_industry_jobs_duration
	//
	// Job duration in seconds
	// Required: true
	Duration *int32 `json:"duration"`

	// get_characters_character_id_industry_jobs_end_date
	//
	// Date and time when this job finished
	// Required: true
	EndDate *strfmt.DateTime `json:"end_date"`

	// get_characters_character_id_industry_jobs_facility_id
	//
	// ID of the facility where this job is running
	// Required: true
	FacilityID *int64 `json:"facility_id"`

	// get_characters_character_id_industry_jobs_installer_id
	//
	// ID of the character which installed this job
	// Required: true
	InstallerID *int32 `json:"installer_id"`

	// get_characters_character_id_industry_jobs_job_id
	//
	// Unique job ID
	// Required: true
	JobID *int32 `json:"job_id"`

	// get_characters_character_id_industry_jobs_licensed_runs
	//
	// Number of runs blueprint is licensed for
	LicensedRuns int32 `json:"licensed_runs,omitempty"`

	// get_characters_character_id_industry_jobs_output_location_id
	//
	// Location ID of the location to which the output of the job will be delivered. Normally a station ID, but can also be a corporation facility
	// Required: true
	OutputLocationID *int64 `json:"output_location_id"`

	// get_characters_character_id_industry_jobs_pause_date
	//
	// Date and time when this job was paused (i.e. time when the facility where this job was installed went offline)
	PauseDate strfmt.DateTime `json:"pause_date,omitempty"`

	// get_characters_character_id_industry_jobs_probability
	//
	// Chance of success for invention
	Probability float32 `json:"probability,omitempty"`

	// get_characters_character_id_industry_jobs_product_type_id
	//
	// Type ID of product (manufactured, copied or invented)
	ProductTypeID int32 `json:"product_type_id,omitempty"`

	// get_characters_character_id_industry_jobs_runs
	//
	// Number of runs for a manufacturing job, or number of copies to make for a blueprint copy
	// Required: true
	Runs *int32 `json:"runs"`

	// get_characters_character_id_industry_jobs_start_date
	//
	// Date and time when this job started
	// Required: true
	StartDate *strfmt.DateTime `json:"start_date"`

	// get_characters_character_id_industry_jobs_station_id
	//
	// ID of the station where industry facility is located
	// Required: true
	StationID *int64 `json:"station_id"`

	// get_characters_character_id_industry_jobs_status
	//
	// status string
	// Required: true
	Status *string `json:"status"`

	// get_characters_character_id_industry_jobs_successful_runs
	//
	// Number of successful runs for this job. Equal to runs unless this is an invention job
	SuccessfulRuns int32 `json:"successful_runs,omitempty"`
}
