package skills

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetCharactersCharacterIDAttributesReader is a Reader for the GetCharactersCharacterIDAttributes structure.
type GetCharactersCharacterIDAttributesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDAttributesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDAttributesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDAttributesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDAttributesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDAttributesOK creates a GetCharactersCharacterIDAttributesOK with default headers values
func NewGetCharactersCharacterIDAttributesOK() *GetCharactersCharacterIDAttributesOK {
	return &GetCharactersCharacterIDAttributesOK{}
}

/*GetCharactersCharacterIDAttributesOK handles this case with default header values.

Attributes of a character
*/
type GetCharactersCharacterIDAttributesOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetCharactersCharacterIDAttributesOKBody
}

func (o *GetCharactersCharacterIDAttributesOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/attributes/][%d] getCharactersCharacterIdAttributesOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDAttributesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDAttributesForbidden creates a GetCharactersCharacterIDAttributesForbidden with default headers values
func NewGetCharactersCharacterIDAttributesForbidden() *GetCharactersCharacterIDAttributesForbidden {
	return &GetCharactersCharacterIDAttributesForbidden{}
}

/*GetCharactersCharacterIDAttributesForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDAttributesForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDAttributesForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/attributes/][%d] getCharactersCharacterIdAttributesForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDAttributesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDAttributesInternalServerError creates a GetCharactersCharacterIDAttributesInternalServerError with default headers values
func NewGetCharactersCharacterIDAttributesInternalServerError() *GetCharactersCharacterIDAttributesInternalServerError {
	return &GetCharactersCharacterIDAttributesInternalServerError{}
}

/*GetCharactersCharacterIDAttributesInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDAttributesInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDAttributesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/attributes/][%d] getCharactersCharacterIdAttributesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDAttributesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDAttributesOKBody get_characters_character_id_attributes_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDAttributesOKBody
*/
type GetCharactersCharacterIDAttributesOKBody struct {

	// get_characters_character_id_attributes_accrued_remap_cooldown_date
	//
	// Neural remapping cooldown after a character uses remap accrued over time
	// Required: true
	AccruedRemapCooldownDate *strfmt.DateTime `json:"accrued_remap_cooldown_date"`

	// get_characters_character_id_attributes_bonus_remaps
	//
	// Number of available bonus character neural remaps
	// Required: true
	BonusRemaps *int32 `json:"bonus_remaps"`

	// get_characters_character_id_attributes_charisma
	//
	// charisma integer
	// Required: true
	Charisma *int32 `json:"charisma"`

	// get_characters_character_id_attributes_intelligence
	//
	// intelligence integer
	// Required: true
	Intelligence *int32 `json:"intelligence"`

	// get_characters_character_id_attributes_last_remap_date
	//
	// Datetime of last neural remap, including usage of bonus remaps
	// Required: true
	LastRemapDate *strfmt.DateTime `json:"last_remap_date"`

	// get_characters_character_id_attributes_memory
	//
	// memory integer
	// Required: true
	Memory *int32 `json:"memory"`

	// get_characters_character_id_attributes_perception
	//
	// perception integer
	// Required: true
	Perception *int32 `json:"perception"`

	// get_characters_character_id_attributes_willpower
	//
	// willpower integer
	// Required: true
	Willpower *int32 `json:"willpower"`
}
