package wallet

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"local/models"
)

// GetCharactersCharacterIDWalletJournalReader is a Reader for the GetCharactersCharacterIDWalletJournal structure.
type GetCharactersCharacterIDWalletJournalReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDWalletJournalReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDWalletJournalOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDWalletJournalForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDWalletJournalInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDWalletJournalOK creates a GetCharactersCharacterIDWalletJournalOK with default headers values
func NewGetCharactersCharacterIDWalletJournalOK() *GetCharactersCharacterIDWalletJournalOK {
	return &GetCharactersCharacterIDWalletJournalOK{}
}

/*GetCharactersCharacterIDWalletJournalOK handles this case with default header values.

Journal entries
*/
type GetCharactersCharacterIDWalletJournalOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDWalletJournalOKBodyItems0
}

func (o *GetCharactersCharacterIDWalletJournalOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/wallet/journal/][%d] getCharactersCharacterIdWalletJournalOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDWalletJournalOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDWalletJournalForbidden creates a GetCharactersCharacterIDWalletJournalForbidden with default headers values
func NewGetCharactersCharacterIDWalletJournalForbidden() *GetCharactersCharacterIDWalletJournalForbidden {
	return &GetCharactersCharacterIDWalletJournalForbidden{}
}

/*GetCharactersCharacterIDWalletJournalForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDWalletJournalForbidden struct {
	Payload *models.Forbidden
}

func (o *GetCharactersCharacterIDWalletJournalForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/wallet/journal/][%d] getCharactersCharacterIdWalletJournalForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDWalletJournalForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDWalletJournalInternalServerError creates a GetCharactersCharacterIDWalletJournalInternalServerError with default headers values
func NewGetCharactersCharacterIDWalletJournalInternalServerError() *GetCharactersCharacterIDWalletJournalInternalServerError {
	return &GetCharactersCharacterIDWalletJournalInternalServerError{}
}

/*GetCharactersCharacterIDWalletJournalInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDWalletJournalInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetCharactersCharacterIDWalletJournalInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/wallet/journal/][%d] getCharactersCharacterIdWalletJournalInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDWalletJournalInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDWalletJournalOKBodyItems0ExtraInfo get_characters_character_id_wallet_journal_extra_info
//
// Extra information for different type of transaction
swagger:model GetCharactersCharacterIDWalletJournalOKBodyItems0ExtraInfo
*/
type GetCharactersCharacterIDWalletJournalOKBodyItems0ExtraInfo struct {

	// get_characters_character_id_wallet_journal_alliance_id
	//
	// alliance_id integer
	AllianceID int32 `json:"alliance_id,omitempty"`

	// get_characters_character_id_wallet_journal_character_id
	//
	// character_id integer
	CharacterID int32 `json:"character_id,omitempty"`

	// get_characters_character_id_wallet_journal_contract_id
	//
	// contract_id integer
	ContractID int32 `json:"contract_id,omitempty"`

	// get_characters_character_id_wallet_journal_corporation_id
	//
	// corporation_id integer
	CorporationID int32 `json:"corporation_id,omitempty"`

	// get_characters_character_id_wallet_journal_destroyed_ship_type_id
	//
	// destroyed_ship_type_id integer
	DestroyedShipTypeID int32 `json:"destroyed_ship_type_id,omitempty"`

	// get_characters_character_id_wallet_journal_job_id
	//
	// job_id integer
	JobID int32 `json:"job_id,omitempty"`

	// get_characters_character_id_wallet_journal_location_id
	//
	// location_id integer
	LocationID int64 `json:"location_id,omitempty"`

	// get_characters_character_id_wallet_journal_npc_id
	//
	// npc_id integer
	NpcID int32 `json:"npc_id,omitempty"`

	// get_characters_character_id_wallet_journal_npc_name
	//
	// npc_name string
	NpcName string `json:"npc_name,omitempty"`

	// get_characters_character_id_wallet_journal_planet_id
	//
	// planet_id integer
	PlanetID int32 `json:"planet_id,omitempty"`

	// get_characters_character_id_wallet_journal_system_id
	//
	// system_id integer
	SystemID int32 `json:"system_id,omitempty"`

	// get_characters_character_id_wallet_journal_transaction_id
	//
	// transaction_id integer
	TransactionID int64 `json:"transaction_id,omitempty"`
}

/*GetCharactersCharacterIDWalletJournalOKBodyItems0 get_characters_character_id_wallet_journal_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDWalletJournalOKBodyItems0
*/
type GetCharactersCharacterIDWalletJournalOKBodyItems0 struct {

	// get_characters_character_id_wallet_journal_amount
	//
	// Transaction amount. Positive when value transferred to the first party. Negative otherwise
	Amount float32 `json:"amount,omitempty"`

	// get_characters_character_id_wallet_journal_balance
	//
	// Wallet balance after transaction occurred
	Balance float32 `json:"balance,omitempty"`

	// get_characters_character_id_wallet_journal_date
	//
	// Date and time of transaction
	// Required: true
	Date *strfmt.DateTime `json:"date"`

	// extra info
	ExtraInfo *GetCharactersCharacterIDWalletJournalOKBodyItems0ExtraInfo `json:"extra_info,omitempty"`

	// get_characters_character_id_wallet_journal_first_party_id
	//
	// first_party_id integer
	FirstPartyID int32 `json:"first_party_id,omitempty"`

	// get_characters_character_id_wallet_journal_first_party_type
	//
	// first_party_type string
	FirstPartyType string `json:"first_party_type,omitempty"`

	// get_characters_character_id_wallet_journal_reason
	//
	// reason string
	Reason string `json:"reason,omitempty"`

	// get_characters_character_id_wallet_journal_ref_id
	//
	// Unique journal reference ID
	// Required: true
	RefID *int64 `json:"ref_id"`

	// get_characters_character_id_wallet_journal_ref_type
	//
	// Transaction type, different type of transaction will populate different fields in `extra_info`
	// Required: true
	RefType *string `json:"ref_type"`

	// get_characters_character_id_wallet_journal_second_party_id
	//
	// second_party_id integer
	SecondPartyID int32 `json:"second_party_id,omitempty"`

	// get_characters_character_id_wallet_journal_second_party_type
	//
	// second_party_type string
	SecondPartyType string `json:"second_party_type,omitempty"`

	// get_characters_character_id_wallet_journal_tax
	//
	// Tax amount received for tax related transactions
	Tax float32 `json:"tax,omitempty"`

	// get_characters_character_id_wallet_journal_tax_reciever_id
	//
	// the corporation ID receiving any tax paid
	TaxRecieverID int32 `json:"tax_reciever_id,omitempty"`
}
